<template>
  <div class="DataTable">
    <p v-if="error" class="ErrorMessage">I apologize, but we have encountered an error. It could be that this symbol does not exist in the New York Stock Exchange</p>
    <p v-if="rateLimitExceeded" class="RateLimitExceeded">This site is using a free, rate limited API. Please be patient and we will be able to retrieve results</p>
    <div class="ChartContainer" v-bind:class="classObj">
      <svg id="StockPrices"></svg>
    </div>
    <spinner v-if="loading"></spinner>
  </div>
</template>

<script>
import Spinner from "./Spinner.vue";
import { drawChart, removeChart } from "@/utils/chartUtils.js";

// errorMessage? I apologize but we have hit our rate limit. Please wait and try again soon to receive up to date information;

export default {
  components: {
    Spinner
  },
  props: {
    entries: Array,
    loading: Boolean,
    rateLimitExceeded: Boolean,
    error: Error
  },
  watch: {
    entries: function(newEntries) {
      if (this.entries.length === 0) {
        removeChart();
      } else {
        drawChart("#StockPrices", newEntries);
      }
    }
  },
  computed: {
    classObj: function() {
      return {
        dataLoaded: !this.loading,
        dataNotLoaded: this.loading
      };
    }
  }
};
</script>

<style>
.DataTable {
  margin: 0 auto;
  text-align: center;
}

.ChartContainer.dataNotLoaded {
  opacity: 0;
  transition: opacity 0.2s ease-out;
}

.ChartContainer.dataLoaded {
  opacity: 1;
  transition: opacity 0.2s ease-in;
}

.ErrorMessage,
.RateLimitExceeded {
  color: red;
}
</style>
